# Changelog

## 2025-04-25 - 6.2.2 - fix(docs)
Update @push.rocks/tapbundle dependency and refine AsyncExecutionStack documentation examples

- Bump @push.rocks/tapbundle from ^5.0.8 to ^5.5.6 in package.json
- Improve README documentation for AsyncExecutionStack with clearer examples for exclusive and non-exclusive task execution
- Demonstrate usage of concurrency controls in AsyncExecutionStack

## 2025-04-25 - 6.2.1 - fix(AsyncExecutionStack tests)
Refactor AsyncExecutionStack tests: update non-exclusive concurrency assertions and clean up test logic

- Replace 'toBe' with 'toEqual' for active and pending counts to ensure consistency
- Simplify default non-exclusive concurrency test by asserting Infinity is non-finite using toBeFalse
- Adjust test comments and scheduling for clarity in concurrency behavior

## 2025-04-25 - 6.2.0 - feat(AsyncExecutionStack)
Improve non-exclusive task management with concurrency limit controls and enhanced monitoring in AsyncExecutionStack.

- Added methods to set and get non-exclusive concurrency limits and statistics (setNonExclusiveMaxConcurrency, getActiveNonExclusiveCount, getPendingNonExclusiveCount, and getNonExclusiveMaxConcurrency).
- Integrated proper waiting and release mechanisms for non-exclusive slots.
- Extended test coverage to validate concurrency limits and ensure correct behavior.

## 2024-10-13 - 6.1.0 - feat(BackpressuredArray)
Add method to check if items are present in BackpressuredArray

- Implemented a new method `checkHasItems` in the BackpressuredArray class to determine if the array contains any items.

## 2024-05-29 to 2024-04-18 - 6.0.15
Minor updates were made to documentation and descriptions.

- Update project description

## 2024-04-18 to 2024-02-25 - 6.0.14
Several updates were made to configurations and json files.

- Updated core components in the codebase
- Modified tsconfig settings
- Revised npmextra.json with githost configurations

## 2024-02-25 to 2024-02-23 - 6.0.13
No relevant changes.

## 2024-02-23 to 2023-11-13 - 6.0.12 to 6.0.8
Multiple core updates were performed to ensure stability and performance.

- Fixed various issues in core components

## 2023-11-13 to 2023-08-14 - 6.0.7 to 6.0.3
Minor internal core updates.

## 2023-08-14 to 2023-07-12 - 6.0.2
Implemented a switch to a new organizational scheme.

## 2023-01-18 to 2022-05-27 - 6.0.0
Updated core functionalities; introduced breaking changes for compatibility with ECMAScript modules.

- Core updates
- Switching from CommonJS to ECMAScript modules

## 2022-05-27 to 2022-05-27 - 5.0.6 to 5.0.0
Minor updates and a significant change in `objectmap` behavior to support async operations.

- Included async behaviors in objectmap as a breaking change

## 2020-05-04 to 2020-02-17 - 4.0.0
Refactored ObjectMap; introduced new features.

- Refactored ObjectMap with concat functionality as a breaking change
- Added .clean() to FastMap

## 2020-02-17 to 2020-02-06 - 3.0.19 to 3.0.15
Enhancements and new functionality in ObjectMap.

- Added object mapping enhancements
- Introduced object map with unique keys
